/**
 * 
 */
package org.gcube.resourcemanagement.model.reference.relations.consistsof;

import org.gcube.com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import org.gcube.informationsystem.model.reference.entities.Resource;
import org.gcube.informationsystem.types.reference.Change;
import org.gcube.informationsystem.types.reference.TypeMetadata;
import org.gcube.informationsystem.utils.TypeVersion;
import org.gcube.resourcemanagement.model.impl.relations.consistsof.HasDeveloperImpl;
import org.gcube.resourcemanagement.model.reference.entities.facets.ContactFacet;

/**
 * HasDeveloper indicates that the target {@link ContactFacet} contains the information related to a 
 * developer of the source resource e.g., the contact points of the developer of a software.
 * 
 * https://wiki.gcube-system.org/gcube/Facet_Based_Resource_Model#HasDeveloper
 * 
 * @author Luca Frosini (ISTI - CNR)
 */
@JsonDeserialize(as=HasDeveloperImpl.class)
@TypeMetadata(
	name = HasDeveloper.NAME, 
	description = "HasDeveloper indicates that the target {@link ContactFacet} contains the information related "
			+ "to a developer of the source resource e.g., the contact points ofthe developer of a software.",
	version = TypeVersion.MINIMAL_VERSION_STRING
)
@Change(version = TypeVersion.MINIMAL_VERSION_STRING, description = TypeVersion.MINIMAL_VERSION_DESCRIPTION)
public interface HasDeveloper<Out extends Resource, In extends ContactFacet> 
	extends HasContact<Out, In> {

	public static final String NAME = "HasDeveloper"; // HasDeveloper.class.getSimpleName();
}
